//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//-----------------     SPIRIT 1 -----------------
//---------------     -------------------
//------       ---------
//--           --
//- :          -
//--          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//---------      SPIRIT 1  -------------
//--           STMxxxxx -
//------------------------------------------------------------------------------

#include "Platform.h"

#ifdef STM8L101_PLATFORM

void Spirit_HW_Config( void )
{
//   
//   SPIRIT1 (SPI)     SPI,      "+"
  GPIO_ExternalPullUpConfig(Spirit_Port, Spirit_SPI_Pins, ENABLE);
//  CS   
  GPIO_Init(Spirit_Port, Spirit_SPICS_Pin , GPIO_Mode_Out_PP_Low_Fast);
  GPIO_SetBits(Spirit_Port, Spirit_SPICS_Pin);
  
//   SPIRIT1
  GPIO_Init(Spirit_Reset_Port, Spirit_Reset_Pin, GPIO_Mode_Out_PP_Low_Fast);
  //    c =  "1"
  GPIO_SetBits(Spirit_Reset_Port, Spirit_Reset_Pin);
  // 
  for (uint32_t I=0; I<0x10000;I++);
  //    c =  "0"
  GPIO_ResetBits(Spirit_Reset_Port, Spirit_Reset_Pin);
  // 
  for (uint32_t I=0; I<0x10000;I++);  

//   SPI
  CLK_PeripheralClockConfig(CLK_Peripheral_SPI, ENABLE);

// SPI
  SPI_Init(SPI_FirstBit_MSB, SPI_BaudRatePrescaler_2, SPI_Mode_Master, SPI_CPOL_Low, SPI_CPHA_1Edge,
           SPI_Direction_2Lines_FullDuplex, SPI_NSS_Soft);
  
//   SPI
  SPI_Cmd(ENABLE);

}

void Spirit_Send_Command (uint8_t Command)
{
//  
  
//    SPI  
while (SPI_GetFlagStatus(SPI_FLAG_TXE) == RESET);

//   SPI_FLAG_RXNE (  )
u8 I = SPI->DR;

//   CS
GPIO_ResetBits(Spirit_Port, Spirit_SPICS_Pin);

//   - 
SPI_SendData(Spirit_Header_COMAND);
//    SPI  
while (((SPI_GetFlagStatus(SPI_FLAG_RXNE))|(SPI_GetFlagStatus(SPI_FLAG_TXE))) == RESET);
//    
MC_STATE[1]=(SPI->DR)&0x0f;

//   - 
SPI_SendData(Command);
//    SPI  
while (((SPI_GetFlagStatus(SPI_FLAG_RXNE))|(SPI_GetFlagStatus(SPI_FLAG_TXE))) == RESET);
//    
MC_STATE[0]=SPI->DR;

//   CS
GPIO_SetBits(Spirit_Port, Spirit_SPICS_Pin);
}


void Spirit_Write_Register(uint8_t cRegAddress, uint8_t cNbBytes, uint8_t* pcBuffer)
{
//    cNbBytes   pcBuffer   SPIRIT1  
//  cRegAddress
u8 I;  
//    SPI  
while (SPI_GetFlagStatus(SPI_FLAG_TXE) == RESET);
//   SPI_FLAG_RXNE (  )
I = SPI->DR;

//   CS
GPIO_ResetBits(Spirit_Port, Spirit_SPICS_Pin);

//   - 
SPI_SendData(Spirit_Header_WRITE);
//    SPI  
while (((SPI_GetFlagStatus(SPI_FLAG_RXNE))|(SPI_GetFlagStatus(SPI_FLAG_TXE))) == RESET);
//    
MC_STATE[1]=(SPI->DR)&0x0f;

//   -     
SPI_SendData(cRegAddress);
//    SPI  
while (((SPI_GetFlagStatus(SPI_FLAG_RXNE))|(SPI_GetFlagStatus(SPI_FLAG_TXE))) == RESET);
//    
MC_STATE[0]=SPI->DR;

//   
  for(I=0; I<cNbBytes; I++)
  {
    while (SPI_GetFlagStatus(SPI_FLAG_TXE) == RESET);
    SPI_SendData(pcBuffer[I]);
  }

//   CS
GPIO_SetBits(Spirit_Port, Spirit_SPICS_Pin);
}

void Spirit_Read_Register(uint8_t cRegAddress, uint8_t cNbBytes, uint8_t* pcBuffer)
{
//    cNbBytes   pcBuffer   SPIRIT1  
//  cRegAddress
u8 I;  
//    SPI  
while (SPI_GetFlagStatus(SPI_FLAG_TXE) == RESET);
//   SPI_FLAG_RXNE (  )
I = SPI->DR;

//   CS
GPIO_ResetBits(Spirit_Port, Spirit_SPICS_Pin);

//   - 
SPI_SendData(Spirit_Header_READ);
//    SPI  
while (((SPI_GetFlagStatus(SPI_FLAG_RXNE))|(SPI_GetFlagStatus(SPI_FLAG_TXE))) == RESET);
//    
MC_STATE[1]=(SPI->DR)&0x0f;

//   -     
SPI_SendData(cRegAddress);
//    SPI  
while (((SPI_GetFlagStatus(SPI_FLAG_RXNE))|(SPI_GetFlagStatus(SPI_FLAG_TXE))) == RESET);
//    
MC_STATE[0]=SPI->DR;

//   
  for(I=0; I<cNbBytes; I++)
  {
    while (SPI_GetFlagStatus(SPI_FLAG_TXE) == RESET);
    SPI_SendData(pcBuffer[I]);
    while (SPI_GetFlagStatus(SPI_FLAG_RXNE) == RESET);
    pcBuffer[I] = SPI_ReceiveData();
  }

//   CS
GPIO_SetBits(Spirit_Port, Spirit_SPICS_Pin);

}

#endif //STM8L101_PLATFORM

#ifdef STM32F1_PLATFORM
void Spirit_HW_Config( void )
{
//   
//  -  
//,   
GPIO_InitTypeDef GPIO_InitStructure;
//,   SPI
SPI_InitTypeDef  SPI_InitStructure; 

//    SPI
//  SPI2
 RCC_APB2PeriphClockCmd(Spirit_RCC_Port | Spirit_RCC_Reset_Port | Spirit_RCC_IRQ_Port | Spirit_RCC_SPI | RCC_APB2Periph_AFIO, ENABLE);   

GPIO_DeInit(Spirit_Port);
GPIO_DeInit(Spirit_Reset_Port);
GPIO_DeInit(Spirit_IRQ_Port); 
SPI_I2S_DeInit(Spirit_SPI);

//  JTAG
GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);
//   SPI1
GPIO_PinRemapConfig(GPIO_Remap_SPI1, ENABLE);

 //     SPI
GPIO_InitStructure.GPIO_Pin = Spirit_SPI_OUT_Pins;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
GPIO_Init(Spirit_Port, &GPIO_InitStructure);

//  CS -  
GPIO_InitStructure.GPIO_Pin = Spirit_SPICS_Pin;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
GPIO_Init(Spirit_Port, &GPIO_InitStructure);

GPIO_InitStructure.GPIO_Pin = Spirit_SPI_IN_Pins;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
GPIO_Init(Spirit_Port, &GPIO_InitStructure);

//  CS -  
GPIO_SetBits(Spirit_Port, Spirit_SPICS_Pin);

//    Spirit1
GPIO_InitStructure.GPIO_Pin = Spirit_Reset_Pin;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
GPIO_Init(Spirit_Reset_Port, &GPIO_InitStructure);

//   Spirit1 ( )
GPIO_InitStructure.GPIO_Pin = Spirit_IRQ_Pin;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
GPIO_Init(Spirit_IRQ_Port, &GPIO_InitStructure);

//  SPI
//  SPI 
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(Spirit_SPI, &SPI_InitStructure); 
  
//  
  SPI_Cmd(Spirit_SPI, ENABLE);
  
//   SPIRIT1
  GPIO_SetBits(Spirit_Reset_Port, Spirit_Reset_Pin);
  // 
  for (uint32_t I=0; I<0x10000;I++);
  //    c =  "0"
  GPIO_ResetBits(Spirit_Reset_Port, Spirit_Reset_Pin);
  // 
  for (uint32_t I=0; I<0x10000;I++);  
}

void Spirit_STM32_IRQ_Config( void )
{
//     
NVIC_InitTypeDef NVIC_InitStructure;
//     
EXTI_InitTypeDef   EXTI_InitStructure;

//     Spirit_IRQ_Pin,  Spirit_IRQ_Port
  GPIO_EXTILineConfig(GPIO_IRQ_PortSource, Spirit_IRQ_PinSource);

//     
  EXTI_InitStructure.EXTI_Line = Spirit_IRQ_EXTI_Line;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;  
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);

  EXTI_ClearITPendingBit(Spirit_IRQ_EXTI_Line);  

//    
  NVIC_InitStructure.NVIC_IRQChannel = Spirit_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}

void Spirit_Send_Command (uint8_t Command)
{
//  
  
//    SPI  
while (SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE) == RESET);

//   SPI_FLAG_RXNE (  )
u8 I = Spirit_SPI->DR;

//   CS
GPIO_ResetBits(Spirit_Port, Spirit_SPICS_Pin);

//   - 
SPI_I2S_SendData(Spirit_SPI, Spirit_Header_COMAND);
//    SPI  
while (((SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_RXNE))|(SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE))) == RESET);
//    
MC_STATE[1]=(Spirit_SPI->DR)&0x0f;

//   - 
SPI_I2S_SendData(Spirit_SPI, Command);
//    SPI  
while (((SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_RXNE))|(SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE))) == RESET);
//    
MC_STATE[0]=Spirit_SPI->DR;

//    CS
for (I=0; I<CLK_TO_CS_DELAY; I++);
//   CS
GPIO_SetBits(Spirit_Port, Spirit_SPICS_Pin);
}


void Spirit_Write_Register(uint8_t cRegAddress, uint8_t cNbBytes, uint8_t* pcBuffer)
{
//    cNbBytes   pcBuffer   SPIRIT1  
//  cRegAddress
u8 I;  
//    SPI  
while (SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE) == RESET);
//   SPI_FLAG_RXNE (  )
I = Spirit_SPI->DR;

//   CS
GPIO_ResetBits(Spirit_Port, Spirit_SPICS_Pin);

//   - 
SPI_I2S_SendData(Spirit_SPI, Spirit_Header_WRITE);
//    SPI  
while (((SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_RXNE))|(SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE))) == RESET);
//    
MC_STATE[1]=(Spirit_SPI->DR)&0x0f;

//   -     
SPI_I2S_SendData(Spirit_SPI, cRegAddress);
//    SPI  
while (((SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_RXNE))|(SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE))) == RESET);
//    
MC_STATE[0]=Spirit_SPI->DR;

//   
  for(I=0; I<cNbBytes; I++)
  {
    while (SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE) == RESET);
    SPI_I2S_SendData(Spirit_SPI, pcBuffer[I]);
  }

//    CS
for (I=0; I<CLK_TO_CS_DELAY; I++);
//   CS
GPIO_SetBits(Spirit_Port, Spirit_SPICS_Pin);
}

void Spirit_Read_Register(uint8_t cRegAddress, uint8_t cNbBytes, uint8_t* pcBuffer)
{
//    cNbBytes   pcBuffer   SPIRIT1  
//  cRegAddress
u8 I;  
//    SPI  
while (SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE) == RESET);
//   SPI_FLAG_RXNE (  )
I = Spirit_SPI->DR;

//   CS
GPIO_ResetBits(Spirit_Port, Spirit_SPICS_Pin);

//   - 
SPI_I2S_SendData(Spirit_SPI, Spirit_Header_READ);
//    SPI  
while (((SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_RXNE))|(SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE))) == RESET);
//    
MC_STATE[1]=(Spirit_SPI->DR)&0x0f;

//   -     
SPI_I2S_SendData(Spirit_SPI, cRegAddress);
//    SPI  
while (((SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_RXNE))|(SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE))) == RESET);
//    
MC_STATE[0]=Spirit_SPI->DR;

//   
  for(I=0; I<cNbBytes; I++)
  {
    while (SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_TXE) == RESET);
    SPI_I2S_SendData(Spirit_SPI, pcBuffer[I]);
    while (SPI_I2S_GetFlagStatus(Spirit_SPI, SPI_I2S_FLAG_RXNE) == RESET);
    pcBuffer[I] = SPI_I2S_ReceiveData(Spirit_SPI);
  }

//    CS
for (I=0; I<CLK_TO_CS_DELAY; I++);
//   CS
GPIO_SetBits(Spirit_Port, Spirit_SPICS_Pin);

}

#endif //STM32F1_PLATFORM


//------------------------------------------------------------------------------
//---------------     SPIRIT 1 -------------------
//---------------     -------------------
//---------------          http://www.promelec.ru/           -------------------
//--------------------------           2012         ----------------------------
//------------------------------------------------------------------------------