//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//-----------------     SPIRIT 1 -----------------
//---------------     -------------------
//------       ---------
//--           --
//- :          -
//--          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

#include "Spirit1_promelec.h"
#include "SPIRIT_Commands.h"
#include "SPIRIT_Reg_Conf.h"
#include "Platform.h"

//    SPIRIT1 (  )
u8 MC_STATE[2];
//    TX  RX 
u8 SyncVcoWordTx;
u8 SyncVcoWordRx;


void Spirit_Reset( void )
{
//  Spirit1     
Spirit_Send_Command(CMD_SRES);
SpiritManagementWaRcoCalibration();

}

void SpiritManagementWaRcoCalibration(void)
{
// - 
uint8_t tmp;
//  
tmp= 0x02;Spirit_Write_Register(0x50, 1, &tmp); 
//   Standby
Spirit_Send_Command(CMD_STANDBY);
do{
// 
    for(uint8_t i=0; i!=0xFF; i++);
//   
     Spirit_Read_Register(MC_STATE0_BASE, 1, &tmp);
    }while((tmp>>1)!=MC_STATE_STANDBY);

//  
tmp= 0x29;Spirit_Write_Register(0xB4, 1, &tmp); 
tmp= 0x06;Spirit_Write_Register(0x50, 1, &tmp); 
do{
Spirit_Send_Command(CMD_READY);
// 
    for(uint16_t i=0; i!=0xFFFF; i++);
//   
     Spirit_Read_Register(MC_STATE0_BASE, 1, &tmp);
    }while((tmp>>1)!=MC_STATE_READY);
}

uint8_t GetSpiritVersion(void)
{
//   
uint8_t tempRegValue;
Spirit_Read_Register(DEVICE_INFO1_PARTNUM, 1, &tempRegValue);
return tempRegValue;
}

void Spirit_Init_STANDBY( void )
{
uint8_t value;
//    STAND_BY
Spirit_Send_Command(COMMAND_STANDBY);
//       STAND_BY
do{
// 
    for(uint8_t i=0; i!=0xFF; i++);
//   
     Spirit_Read_Register(MC_STATE0_BASE, 1, &value);
    }while((value>>1)!=MC_STATE_STANDBY);
}

void Spirit_Init_READY( void )
{
uint8_t value;
//    ""
Spirit_Send_Command(COMMAND_READY);
do{
// 
 for(uint8_t i=0; i!=0xFF; i++);
      
//   
  Spirit_Read_Register(MC_STATE0_BASE, 1, &value);
}while((value>>1)!=MC_STATE_READY);  
}

void Spirit_Init_LOCKTX( void )
{
uint8_t value;
//    "LOCKTX"
Spirit_Send_Command(COMMAND_LOCKTX);
do{
// 
 for(uint8_t i=0; i!=0xFF; i++);
      
//   
  Spirit_Read_Register(MC_STATE0_BASE, 1, &value);
}while((value>>1)!=MC_STATE_LOCK);  
}

void Spirit_Init_LOCKRX( void )
{
uint8_t value;
//    "LOCKRX"
Spirit_Send_Command(COMMAND_LOCKRX);
do{
// 
 for(uint8_t i=0; i!=0xFF; i++);
      
//   
  Spirit_Read_Register(MC_STATE0_BASE, 1, &value);
}while((value>>1)!=MC_STATE_LOCK);  
}

void Spirit_TX( void )
{
//   
Spirit_Write_Register(SYNTH_CONFIG1_BASE, 1, (uint8_t*) &SYNTH_CONFIG);
Spirit_Write_Register(SYNT3_BASE, 4, (uint8_t*) &SYNT3_4);
// 
uint8_t tmp;
tmp = 0x11; Spirit_Write_Register(0xa9, 1, &tmp); /* Enable VCO_L buffer */
tmp = 0x20; Spirit_Write_Register(PM_CONFIG1_BASE, 1, &tmp); /* Set SMPS switching frequency */  
  
Spirit_Send_Command(COMMAND_TX);
}


void Spirit_RX()
{
uint8_t i;
  
Spirit_Write_Register(SYNTH_CONFIG1_BASE, 1, (uint8_t*) &SYNTH_CONFIG);
Spirit_Write_Register(SYNT3_BASE, 4, (uint8_t*) &SYNT3);
Spirit_Write_Register(UNDOC1_BASE, 1, (uint8_t*) &UNDOC1[0]);
Spirit_Write_Register(UNDOC1_BASE+1, 1, (uint8_t*) &UNDOC1[1]);
Spirit_Write_Register(UNDOC1_BASE+2, 1, (uint8_t*) &UNDOC1[2]);
Spirit_Write_Register(PM_CONFIG1_BASE, 1, (uint8_t*) &PM_CONFIG1);
Spirit_Write_Register(PA_POWER0_BASE, 1, (uint8_t*) &PA_POWER0);


Spirit_Send_Command(COMMAND_RX);
for(i=0; i!=0xFF; i++);
 
Spirit_Write_Register(UNDOC2_BASE, 1, (uint8_t*) &UNDOC21);
Spirit_Write_Register(UNDOC2_BASE, 1, (uint8_t*) &UNDOC22);

do{
// 
 for(i=0; i!=0xFF; i++);
    
//   
  Spirit_Read_Register(MC_STATE0_BASE, 1, &i);
}while((i>>1)!=MC_STATE_RX);

//   ,  
Spirit_Read_Register(IRQ_STATUS3_BASE, 1, (uint8_t*) &i); 
Spirit_Read_Register(IRQ_STATUS2_BASE, 1, (uint8_t*) &i); 
Spirit_Read_Register(IRQ_STATUS1_BASE, 1, (uint8_t*) &i); 
Spirit_Read_Register(IRQ_STATUS0_BASE, 1, (uint8_t*) &i); 
}


void Spirit_Radio_Init()
{
//   
  
//  Vtune
  uint8_t value = 0xA0;
  Spirit_Write_Register(0x9F, 1, &value);
//   STANDBY
  Spirit_Init_STANDBY();
  
//   XO_RCO_TEST_BASE
  Spirit_Read_Register(XO_RCO_TEST_BASE, 1, &value);
// 
  value&=0xF7;
//
  Spirit_Write_Register(XO_RCO_TEST_BASE, 1, &value);

//   READY
  Spirit_Init_READY();

//   
//   ANA_FUNC_CONF0_BASE
  Spirit_Read_Register(ANA_FUNC_CONF0_BASE, 1, &value);
// 
  value|=SELECT_24_26_MHZ_MASK;;
//
  Spirit_Write_Register(ANA_FUNC_CONF0_BASE, 1, &value);  

  
//     SPIRIT1
Spirit_Write_Register(CHNUM_BASE, 1, (uint8_t*) &CHNUM);
//    SPIRIT1
Spirit_Write_Register(CHSPACE_BASE, 4, (uint8_t*) &CHSPACE);
//    SPIRIT1
Spirit_Write_Register(MOD1_BASE, 4, (uint8_t*) &MOD1);

// -----------    ------------
// --------    ------------------
//  VCO (H)
  Spirit_Read_Register(SYNTH_CONFIG1_BASE, 1, &value);
  value &=0xF9;
  value |=0x02;
  Spirit_Write_Register(SYNTH_CONFIG1_BASE, 1, &value);
  
//    
  Spirit_Write_Register(SYNT3_BASE, 4, (uint8_t*) &SYNT3_1);
  
//    REFDIV
  Spirit_Read_Register(SYNTH_CONFIG1_BASE, 1, &value);
  value |=0x80;
  Spirit_Write_Register(SYNTH_CONFIG1_BASE, 1, &value);

//  VCO (H).....   0xDB
  Spirit_Read_Register(SYNTH_CONFIG1_BASE, 1, &value);
  value &=0xF9;
  value |=0x02;
  Spirit_Write_Register(SYNTH_CONFIG1_BASE, 1, &value);

//    
  Spirit_Write_Register(SYNT3_BASE, 4, (uint8_t*) &SYNT3_2);
  
//  
  value = 0x19;
  Spirit_Write_Register(0xA1, 1, &value);
//  
//   XO_RCO_TEST_BASE
  Spirit_Read_Register(PROTOCOL2_BASE, 1, &value);
// 
  value|= PROTOCOL2_VCO_CALIBRATION_MASK;
//
  Spirit_Write_Register(PROTOCOL2_BASE, 1, &value);  
  
//    LOCKTX  
  Spirit_Init_LOCKTX();  
//    TX
   Spirit_Read_Register(RCO_VCO_CALIBR_OUT0_BASE, 1, &SyncVcoWordTx);
   SyncVcoWordTx&=0x7F;
//   READY
  Spirit_Init_READY();

  Spirit_Read_Register(SYNTH_CONFIG1_BASE, 1, &value);
  value &=0xF9;
  value |=0x02;
  Spirit_Write_Register(SYNTH_CONFIG1_BASE, 1, &value);
//    + 480300  ( -  ,   )
//    
  Spirit_Write_Register(SYNT3_BASE, 4, (uint8_t*) &SYNT3_3);
  
//    LOCKRX  
  Spirit_Init_LOCKRX();    
//    RX
   Spirit_Read_Register(RCO_VCO_CALIBR_OUT0_BASE, 1, &SyncVcoWordRx);
   SyncVcoWordRx&=0x7F;
//   READY
  Spirit_Init_READY();   
  
//    :
//   XO_RCO_TEST_BASE
  Spirit_Read_Register(PROTOCOL2_BASE, 1, &value);
// 
  value&= ~PROTOCOL2_VCO_CALIBRATION_MASK;
//
  Spirit_Write_Register(PROTOCOL2_BASE, 1, &value);    

//    REFDIV
  Spirit_Read_Register(SYNTH_CONFIG1_BASE, 1, &value);
  value &=0x7F;
//  value |=0x02;
  Spirit_Write_Register(SYNTH_CONFIG1_BASE, 1, &value);

// VCO (H)
  Spirit_Read_Register(SYNTH_CONFIG1_BASE, 1, &value);
  value &=0xF9;
  value |=0x02;
  Spirit_Write_Register(SYNTH_CONFIG1_BASE, 1, &value);  
  

//     ()
  Spirit_Write_Register(SYNT3_BASE, 4, (uint8_t*) &SYNT3_4);
  
//  
  value = 0x11;
  Spirit_Write_Register(0xA1, 1, &value);
  
//  
  Spirit_Read_Register(RCO_VCO_CALIBR_IN1_BASE, 1, &value);
  value &=0x80;
  value |=SyncVcoWordTx;
  Spirit_Write_Register(RCO_VCO_CALIBR_IN1_BASE, 1, &SyncVcoWordTx);
  
  Spirit_Read_Register(RCO_VCO_CALIBR_IN0_BASE, 1, &value);
  value &=0x80;
  value |=SyncVcoWordRx;  
  Spirit_Write_Register(RCO_VCO_CALIBR_IN0_BASE, 1, &SyncVcoWordRx);  
}


void Spirit_Config()
{
//     Spirit (, , ,   ..)
  //  :
Spirit_Write_Register(PCKTCTRL1_BASE, 1, (uint8_t*) &PCKTCTRL1);
Spirit_Write_Register(PCKT_FLT_OPTIONS_BASE, 1, (uint8_t*) &PCKT_FLT_OPTIONS1);
Spirit_Write_Register(PCKTCTRL4_BASE, 10, (uint8_t*) &PCKTCTRL4);  
//  
Spirit_Write_Register(PCKT_FLT_OPTIONS_BASE, 1, (uint8_t*) &PCKT_FLT_OPTIONS2);
Spirit_Write_Register(PCKT_FLT_GOALS_BROADCAST_BASE, 3, (uint8_t*) &PCKT_FLT_GOALS_BROADCAST);  
//  
Spirit_Write_Register(IRQ_MASK3_BASE, 4, (uint8_t*) &IRQ_MASK3);  
//   
Spirit_Write_Register(PCKTLEN1_BASE, 2, (uint8_t*) &PCKTLEN1);  
//  SQI
Spirit_Write_Register(QI_BASE, 1, (uint8_t*) &QI);  
//  TimeoutMs  
Spirit_Write_Register(TIMERS5_RX_TIMEOUT_PRESCALER_BASE, 2, (uint8_t*) &TIMERS5_RX_TIMEOUT_PRESCALER);
Spirit_Write_Register(PCKT_FLT_OPTIONS_BASE, 2, (uint8_t*) &PCKT_FLT_OPTIONS3);  
//   
uint8_t q[4];
Spirit_Read_Register(IRQ_STATUS3_BASE, 4, (uint8_t*) q); 
}

void Spirit_IRQ()
{
//  
Spirit_Write_Register(GPIO0_CONF_BASE, 1, (uint8_t*) &GPIO0_CONF);
}

//------------------------------------------------------------------------------
//-----------------     SPIRIT 1 -----------------
//---------------     -------------------
//---------------          http://www.promelec.ru/           -------------------
//--------------------------           2012         ----------------------------
//------------------------------------------------------------------------------