//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//-----------------     SPIRIT 1 -----------------
//---------------     -------------------
//------       ---------
//--           --
//- :          -
//--          -
//----  :   yagov@promelec.ru  support@promelec.ru -----
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

#ifdef STM8L101_PLATFORM
#include "stm8l10x.h"
#endif //STM8L101_PLATFORM

#ifdef STM32F1_PLATFORM
#include "stm32f10x.h"
#endif //STM32F1_PLATFORM

#define	DEVICE_INFO1_PARTNUM	((uint8_t)(0xF0))//   

#define LINEAR_FIFO_ADDRESS 0xFF                 //   

//  SPIRIT
#define  MC_STATE_STANDBY           0x40	/*!< STANDBY */
#define  MC_STATE_SLEEP             0x36	/*!< SLEEP */
#define  MC_STATE_READY             0x03	/*!< READY */
#define  MC_STATE_PM_SETUP          0x3D	/*!< PM_SETUP */
#define  MC_STATE_XO_SETTLING       0x23	/*!< XO_SETTLING */
#define  MC_STATE_SYNTH_SETUP       0x53	/*!< SYNT_SETUP */
#define  MC_STATE_PROTOCOL          0x1F	/*!< PROTOCOL */
#define  MC_STATE_SYNTH_CALIBRATION 0x4F	/*!< SYNTH */
#define  MC_STATE_LOCK              0x0F	/*!< LOCK */
#define  MC_STATE_RX                0x33	/*!< RX */
#define  MC_STATE_TX                0x5F	/*!< TX */

void Spirit_Reset( void );
void SpiritManagementWaRcoCalibration(void);
uint8_t GetSpiritVersion(void);
void Spirit_Init_STANDBY( void );
void Spirit_Init_READY( void );
void Spirit_Init_LOCKTX( void );
void Spirit_TX( void );
void Spirit_RX();
void Spirit_Radio_Init();
void Spirit_Config();
void Spirit_IRQ();

//------------------------------------------------------------------------------
//-----------------     SPIRIT 1 -----------------
//---------------     -------------------
//---------------          http://www.promelec.ru/           -------------------
//--------------------------           2012         ----------------------------
//------------------------------------------------------------------------------